package fr.lri.keller.democ5;

import android.os.AsyncTask;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.TextView;

public class DemoActivity extends AppCompatActivity {

    private TextView affichage;
    private WaitingThread wthread;

    private class WaitingThread extends AsyncTask<Void, Integer, Integer> {
        private final int wait = 5000;
        private final int number = 6;

        @Override
        protected void onPreExecute() {
            affichage.setText("Lancement du thread...");
        }

        @Override
        protected Integer doInBackground(Void... voids) {
            for (int count = 0; count < number; count++) {
                try {
                    Thread.sleep(wait);
                    publishProgress(count+1);
                } catch (InterruptedException e) {
                    break;
                }
            }
            return number;
        }

        @Override
        protected void onProgressUpdate(Integer... counts) {
            int time = counts[0] * wait / 1000;
            affichage.setText("Le thread s'exécute depuis " + time + " secondes");
        }

        @Override
        protected void onPostExecute(Integer res) {
            int time = res * wait / 1000;
            affichage.setText("Le thread a fini ; il s'est exécuté pendant " + time + " secondes");
        }
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_demo);
        affichage = (TextView) findViewById(R.id.affichage);
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_demo, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    public void lancer(View view) {
        if (wthread == null || wthread.getStatus() == AsyncTask.Status.FINISHED) {
            wthread = new WaitingThread();
            wthread.execute();
        }
    }
}
